"""
utilitaires créole
"""
import unicodedata
from .i18n import _


def normalize_family(family_name: str,
                     check_name: bool=True,
                     allow_dot: bool=False) -> str:
    """replace space, accent, uppercase, ... by valid character
    """
    f = family_name
    f = f.replace('-', '_')
    if not allow_dot:
        f = f.replace('.', '_')
    f = f.replace(' ', '_')
    nfkd_form = unicodedata.normalize('NFKD', f)
    f = ''.join([c for c in nfkd_form if not unicodedata.combining(c)])
    f = f.lower()
    if check_name and f == 'containers':
        raise ValueError(_('"{0}" is a forbidden family name'.format(f)))
    return f

